#! /usr/bin/env python
# -*- coding: utf-8 -*-


def ouvrirfich(fich):
    try:
        liste = file(fich).readlines()
        return liste
    except:
        print "Fichier "+fich+" introuvable."

def ecrirefich(fich,liste):
    fh = file(fich,'w')
    for i in liste:
        if i[-1:] != '\n':
            i = i+'\n'
        fh.write(i)
    fh.close()

def modifie_conf(fich,dico):
    liste = ouvrirfich(fich)
    for i in liste:
        for j in dico.keys():
            if j == i[:len(j)]:
                liste[liste.index(i)] = '%s = %s'%(j, dico[j])
    ecrirefich(fich,liste)

def main():
   from optparse import OptionParser
   
   parser = OptionParser()
   
   parser.add_option("--desactive_contenu", dest="desactive_contenu",
   help="Desactive tout filtrage sur le contenu",action="store_true")
   
   parser.add_option("--active_contenu", dest="active_contenu",
   help="Active le filtrage sur le contenu sans les META tags",action="store_true")
   
   parser.add_option("--active_meta", dest="active_meta",
   help="Active le filtrage sur les META/TITLE tags",action="store_true")
   
   (options, args) = parser.parse_args()

   if options.desactive_contenu:
       dico = {'anonregexplist':         "'/etc/dansguardian/lists/empty'", 
               'exceptionregexpurllist': "'/etc/dansguardian/lists/empty'",
               'greyregexpurllist':      "'/etc/dansguardian/lists/empty'",
               'bannedphraselist':       "'/etc/dansguardian/lists/empty'",
               'weightedphraselist':     "'/etc/dansguardian/lists/empty'",
               'exceptionphraselist':    "'/etc/dansguardian/lists/empty'",
               'bannedregexpurllist':    "'/etc/dansguardian/lists/empty'",
               'bannedextensionlist':    "'/etc/dansguardian/lists/empty'",
               'bannedmimetypelist':     "'/etc/dansguardian/lists/empty'",
               'contentregexplist':      "'/etc/dansguardian/lists/empty'",
               'enablepics': 'off',
               'naughtynesslimit': "100"
               }       
       modifie_conf('/etc/dansguardian/dansguardianf1.conf',dico)
       modifie_conf('/etc/dansguardian/dansguardianf2.conf',dico)

       dico = {'weightedphrasemode': '2',
               'phrasefiltermode':   '1'}
       modifie_conf('/etc/dansguardian/dansguardian.conf',dico)

   if options.active_contenu:
       dico = {'anonregexplist':         "'/etc/dansguardian/lists/anonregexplist'", 
               'exceptionregexpurllist': "'/etc/dansguardian/lists/exceptionregexpurllist'",
               'greyregexpurllist':      "'/etc/dansguardian/lists/greyregexpurllist'",
               'bannedphraselist':       "'/etc/dansguardian/lists/bannedphraselist'",
               'weightedphraselist':     "'/etc/dansguardian/lists/weightedphraselist'",
               'exceptionphraselist':    "'/etc/dansguardian/lists/exceptionphraselist'",
               'bannedregexpurllist':    "'/etc/dansguardian/lists/bannedregexpurllist'",
               'bannedextensionlist':    "'/etc/dansguardian/lists/bannedextensionlist'",
               'bannedmimetypelist':     "'/etc/dansguardian/lists/bannedmimetypelist'",
               'contentregexplist':      "'/etc/dansguardian/lists/contentregexplist'",
               'enablepics': 'on',
               'naughtynesslimit': "100"
               }       
       modifie_conf('/etc/dansguardian/dansguardianf1.conf',dico)
       modifie_conf('/etc/dansguardian/dansguardianf2.conf',dico)

       dico = {'weightedphrasemode': '2',
               'phrasefiltermode':   '1'}
       modifie_conf('/etc/dansguardian/dansguardian.conf',dico)

   if options.active_meta:
       dico = {'anonregexplist':         "'/etc/dansguardian/lists/anonregexplist'", 
               'exceptionregexpurllist': "'/etc/dansguardian/lists/exceptionregexpurllist'",
               'greyregexpurllist':      "'/etc/dansguardian/lists/greyregexpurllist'",
               'bannedphraselist':       "'/etc/dansguardian/lists/bannedphraselist'",
               'weightedphraselist':     "'/etc/dansguardian/lists/weightedphraselist.meta'",
               'exceptionphraselist':    "'/etc/dansguardian/lists/exceptionphraselist'",
               'bannedregexpurllist':    "'/etc/dansguardian/lists/bannedregexpurllist'",
               'bannedextensionlist':    "'/etc/dansguardian/lists/bannedextensionlist'",
               'bannedmimetypelist':     "'/etc/dansguardian/lists/bannedmimetypelist'",
               'contentregexplist':      "'/etc/dansguardian/lists/contentregexplist'",
               'enablepics': 'on',
               'naughtynesslimit': "50"
               }       
       modifie_conf('/etc/dansguardian/dansguardianf1.conf',dico)
       modifie_conf('/etc/dansguardian/dansguardianf2.conf',dico)

       dico = {'weightedphrasemode': '1',
               'phrasefiltermode':   '3'}
       modifie_conf('/etc/dansguardian/dansguardian.conf',dico)

if __name__ == '__main__':
    main()

