#!/usr/bin/perl

use POSIX "mktime" ;

#les variables 

my $chemin ;
my $time_jourcourant ;
my $jour ;
my @jour_courant ;
my $time_dimanche ;
my $cpt ;
my $ligne_requete ;
my @vect ;
my @num_jour_semaine ;
my $timestamp_log ;
my $name_file ;
$chemin = "/var/log/ead/" ;


use strict;
use Getopt::Std ;



my $version = "version 1.0";


use vars qw($opt_i $opt_j  $opt_v $opt_h);

#==============================================================================
#==============================================================================
#
#        
#                           Gestion des options
#
#==============================================================================

#<===========Copyright========>

my $copyright = "\n";
$copyright .= "    Perl-dispatch-sem v. $version.\n\n";
$copyright .= "    Utilitaire d'index d'un fichier de log.\n";
$copyright .= "    Copyright (c) 2000 Kévin Reverchon <kreverchon\@ac-dijon.fr>.\n\n";
$copyright .= "    Perl-dispatch-sem EST UN LOGICIEL LIBRE. SE RÉFÉRER AU CODE SOURCE\n";
$copyright .= "    POUR LA LICENCE D'UTILISATION ET DE COPIE.\n\n";

#<===========Message d'Aide==========>


my $help = "\n";
$help .= "Perl-dispatch-sem v. $version.\n";
$help .= "Usage : 'perl-dispatch-sem -i fichier_log -j fichier log jour courant '\n\n";
$help .= " perl-dispatch-sem -h : affiche ce message d'aide.\n";
$help .= " perl-dispatch-sem -v : affiche la version et la notice de copyright de CRéOLE.\n";

#<============lecture de la liste des options============>

unless( getopts('i:j:vh') )
{
    print STDERR $help;
    exit 0;
}

#affichage la version et le copyright si option -v

if( $opt_v )
{
    print STDERR $copyright;
    exit 0;
}

#affichage de l'aide si option -h

if($opt_h) 
{
    print STDERR $help;
    exit 0;
}

#gestion de l'option i
# Si l'option -i manque, affichage de l'aide
my $fichier_log ;
if( $opt_i ) 
{


    $fichier_log = $opt_i ;
    
} else {

    print STDERR $help;
    exit 0;
        
}

my $fichier_log_jc ;

if( $opt_j )
{

    $fichier_log_jc = $opt_j ;
} else {

    print STDERR $help ;
    exit 0 ;
}



#=======================================================================================
#                                 fin gestion des options
#=======================================================================================






my $nb_log ;
$nb_log= 0 ;

#recupère le timestamp du jour courant
$time_jourcourant = time ;

#met le timestamps jour courant au format humain
@jour_courant = localtime(time) ;

#creer un timestamp du jour courant a l'heure 00h00 (etape1 pour avoir le timestamp du dimache de la semaine courante)
$time_dimanche = mktime(0, 0, 0, $jour_courant[3], $jour_courant[4], $jour_courant[5]) ;
chomp ($time_dimanche) ;
#etape2: on connait le numero du jour de la semaine du jour courant, donc on peut facilement remonter au timestamp du dimanche de la semaine courante
for ($cpt = 1; $cpt <= $jour_courant[6]; $cpt++)
{
    $time_dimanche = $time_dimanche - 86400 ;
}


#ouvre le ficheir log souhaité
open(FICHIER_LOG, $fichier_log );

while (<FICHIER_LOG>)
 {

#split du log pour récipérer le timestamp 
     $ligne_requete = $_ ;

    @vect = split (/[ ]+/, $ligne_requete) ;

    $timestamp_log = $vect[0] ;

    @num_jour_semaine = localtime($timestamp_log) ;
chomp ($time_jourcourant) ;    
chomp ($timestamp_log) ;



#vérification que le timestamp du log se trouve bien dans l'intervalle dimanche de la semaine courante et timestamp jour courant
if ( ( $timestamp_log > $time_dimanche ) && ( $timestamp_log < $time_jourcourant ) )
{

	
     $nb_log++ ;
	if ( $num_jour_semaine[6] == 0 )
    {
	$name_file = "/var/log/ead/dimanche-sem.log" ;
    }

    if ( $num_jour_semaine[6] == 1 )
    {
	$name_file = "/var/log/ead/lundi-sem.log" ;
    }

    if ( $num_jour_semaine[6] == 2 )
    {
	$name_file = "/var/log/ead/mardi-sem.log" ;
    }

    if ( $num_jour_semaine[6] == 3 )
    {
	$name_file = "/var/log/ead/mercredi-sem.log" ;
    }

    if ( $num_jour_semaine[6] == 4 )
    {
	$name_file = "/var/log/ead/jeudi-sem.log" ;
    }

    if ( $num_jour_semaine[6] == 5 )
    {
	$name_file = "/var/log/ead/vendredi-sem.log" ;
    }

    if ( $num_jour_semaine[6] == 6 )
    {
	$name_file = "/var/log/ead/samedi-sem.log" ;
    }
#ecriture dans le bon fichier de log du jour du log
	open ( FICHIER_JOURLOG, ">>$name_file" ) ;
    {
	print ( FICHIER_JOURLOG $ligne_requete ) ;
    }
    close ( FICHIER_JOURLOG );
    
}
}
close (FICHIER_LOG) ;

#ecriture dans le bon fichier de log du jour du log
open ( FICHIER_NBLIGNE, ">$fichier_log_jc" ) ;
    {
	print ( FICHIER_NBLIGNE $nb_log ) ;
    }
    close ( FICHIER_NBLIGNE );
