#!/usr/bin/perl

# Création d'un fichier index du access.log

#    Conception :
#    CETIAD - Revrchon kévin <kreverchon@ac-dijon.fr>

#    Copyright (C) 2000 


#    En attendant une traduction officielle de la GPL, la notice de 
#    copyright demeure en anglais.


#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#    Se reporter à la documentation envoyée avec le programme pour la notice.
#    Si elle manquait, envoyer un email à <kreverchon@ac-dijon.fr>


use strict;
use Getopt::Std ;

#Déclaration des variables
#Déclaration de la version


my $version = "version 1.0";


use vars qw($opt_i $opt_o $opt_v $opt_h);
my $cpt;
my @tab;
my @vect_heure;
my @vect_requete ;
my @jour;
my $ligne_debut;
my $buffer_fic;
my $fichier_log;
my $fichier_index;
my $cpt_heure ;
#==============================================================================
#==============================================================================
#
#        
#                           Gestion des options
#
#==============================================================================

#<===========Copyright========>

my $copyright = "\n";
$copyright .= "    Perl-index-jour-courant v. $version.\n\n";
$copyright .= "    Utilitaire d'index d'un fichier de log.\n";
$copyright .= "    Copyright (c) 2000 Kévin Reverchon <kreverchon\@ac-dijon.fr>.\n\n";
$copyright .= "    Perl-index EST UN LOGICIEL LIBRE. SE RÉFÉRER AU CODE SOURCE\n";
$copyright .= "    POUR LA LICENCE D'UTILISATION ET DE COPIE.\n\n";

#<===========Message d'Aide==========>


my $help = "\n";
$help .= "Perl-index-jour-courant v. $version.\n";
$help .= "Usage : 'perl-index -i fichier_log -o fichier index '\n\n";
$help .= " perl-index-jour-courant -h : affiche ce message d'aide.\n";
$help .= " perl-index-jour-courant -v : affiche la version et la notice de copyright de CRéOLE.\n";

#<============lecture de la liste des options============>

unless( getopts('i:o:vh') )
{
    print STDERR $help;
    exit 0;
}

#affichage la version et le copyright si option -v

if( $opt_v )
{
    print STDERR $copyright;
    exit 0;
}

#affichage de l'aide si option -h

if($opt_h) 
{
    print STDERR $help;
    exit 0;
}

#gestion de l'option i
# Si l'option -i manque, affichage de l'aide

if( $opt_i ) 
{


    $fichier_log = $opt_i ;
    
} else {

    print STDERR $help;
    exit 0;
        
}

#gestion de l'option o
# Si l'option -o manque, affichage de l'aide

if( $opt_o ) 
{


    $fichier_index = $opt_o ;
    
} else {

    print STDERR $help;
    exit 0;
        
}
 
##############################################################################################################################################################################################################                                         Programme                                                     ##############################################################################################################################################################################################################



#initialisation du tableau, cp = les jours de la semaine, ind les heures de la journée
my $ind ;
for ($ind=0; $ind<=23; $ind++)
    {
	$tab[$ind] = 0 ;
    }


#RAZ du fichier index
open (FICHIER_INDEX, ">$fichier_index");
close (FICHIER_INDEX);


open(FICHIER, $fichier_log);
while (<FICHIER>)
 {

    chomp $_;



    @vect_requete = split (/[ ]+/, $_, 1);


@jour = localtime($vect_requete[0]) ;

    for ($cpt_heure=0 ; $cpt_heure <= 23 ; $cpt_heure++)
    {
	if ($jour[2] == $cpt_heure)
	{
	    $tab[$cpt_heure] = $tab[$cpt_heure] + 1 ;
	}
    }
}

close(FICHIER);

#======================================================================================================                                          Partie 2 du programme                                        =======================================================================================================*Ecriture dans le fichier index des données                                                            *Structure des données:  jour:heure:debut de ligne pour cette heure:nombre de lignes                   *Remarque: si pas de données pour un jour et une heure precise, le programme ecrit -1 pour le debut de ligne et pour le nombre de ligne
#====================================================================================================== 

#cpt represente le jour de la semaine
$ligne_debut = 1;


for ($cpt=0; $cpt<=23; $cpt++)
{
   
	if ($tab[$cpt] != "0")
	{
	    print $cpt.":".$ligne_debut.":".$tab[$cpt]."\n";
		   $buffer_fic = $cpt.":".$ligne_debut.":".$tab[$cpt]."\n";
	$ligne_debut = $ligne_debut + $tab[$cpt];

	}else{
	    
	  print  $cpt.":"."-1".":"."-1"."\n";
$buffer_fic = $cpt.":"."-1".":"."-1"."\n";
      }

open (FICHIER_INDEX, ">>$fichier_index");
 print(FICHIER_INDEX $buffer_fic);
close (FICHIER_INDEX);
}
