#!/usr/bin/perl

use POSIX "mktime" ;

#les variables 


my $time_jourcourant ;
my @jour_courant ;
my $time_debut_jc ;
my $cpt ;
my $ligne_requete ;
my @vect ;
my @num_jour_semaine ;
my $timestamp_log ;
my @tab_jc_heure ;
my $debut_ligne ;
my $buffer ; 
my $heure ;
use strict;
use Getopt::Std ;
my $test ;
my $cpt_ligne_jc ;


my $version = "version 1.0";


use vars qw($opt_i $opt_o $opt_v $opt_h);

#==============================================================================
#==============================================================================
#
#        
#                           Gestion des options
#
#==============================================================================

#<===========Copyright========>

my $copyright = "\n";
$copyright .= "    Perl-index-new-jc v. $version.\n\n";
$copyright .= "    Utilitaire d'index d'un fichier de log.\n";
$copyright .= "    Copyright (c) 2000 Kévin Reverchon <kreverchon\@ac-dijon.fr>.\n\n";
$copyright .= "    Perl-index-new-jc EST UN LOGICIEL LIBRE. SE RÉFÉRER AU CODE SOURCE\n";
$copyright .= "    POUR LA LICENCE D'UTILISATION ET DE COPIE.\n\n";

#<===========Message d'Aide==========>


my $help = "\n";
$help .= "Perl-dispatch-sem v. $version.\n";
$help .= "Usage : 'perl-index-new-jc -i fichier_log -o fichier index '\n\n";
$help .= " perl-index-new-jc -h : affiche ce message d'aide.\n";
$help .= " perl-index-new-jc -v : affiche la version et la notice de copyright de CRéOLE.\n";

#<============lecture de la liste des options============>

unless( getopts('i:o:vh') )
{
    print STDERR $help;
    exit 0;
}

#affichage la version et le copyright si option -v

if( $opt_v )
{
    print STDERR $copyright;
    exit 0;
}

#affichage de l'aide si option -h

if($opt_h) 
{
    print STDERR $help;
    exit 0;
}

#gestion de l'option i
# Si l'option -i manque, affichage de l'aide
my $fichier_log ;
if( $opt_i ) 
{


    $fichier_log = $opt_i ;
    
} else {

    print STDERR $help;
    exit 0;
        
}

my $fichier_index_jc ;
if ( $opt_o )
{
    $fichier_index_jc = $opt_o ;
} else {

    print STDERR $help ;
    exit 0 ;
}


#=======================================================================================
#                                 fin gestion des options
#=======================================================================================


#initialisation du tableau


    for ($heure = 0 ; $heure <= 23 ; $heure++ )
    {
	$tab_jc_heure[$heure] = 0 ;
    }


#recupère le timestamp du jour courant
$time_jourcourant = time ;

#met le timestamps jour courant au format humain
@jour_courant = localtime(time) ;

#creer un timestamp du jour courant a l'heure 00h00 
$time_debut_jc = mktime(0, 0, 0, $jour_courant[3], $jour_courant[4], $jour_courant[5]) ;


#variable de test pour savoir si on est dans le bon timestamp du jour courant
$test = 0 ;
$cpt_ligne_jc = 1 ;

#ouvre le fichier log access.log normalement
open(FICHIER, $fichier_log );

while (<FICHIER>)
 {

#split du log pour récipérer le timestamp 
     $ligne_requete = $_ ;

    @vect = split (/[ ]+/, $ligne_requete) ;

    $timestamp_log = $vect[0] ;

    @num_jour_semaine = localtime($timestamp_log) ;

#recupere l'heure
$heure = $num_jour_semaine[2] ; 

#vérification que le timestamp du log se trouve bien dans l'intervalle debut du jour courant et timestamp actuel jour courant
    
	 if ( ( $timestamp_log > $time_debut_jc ) && ( $timestamp_log < $time_jourcourant ) )
	 {
print " $time_debut_jc :" ;
print " $timestamp_log :" ;
print " $time_jourcourant \n" ;
$test = 1 ;
	     $tab_jc_heure[$heure]++ ;

	 }
	
if ($test == 0)
{
	$cpt_ligne_jc++ ;
}
}
close (FICHIER_LOG) ;

$debut_ligne = $cpt_ligne_jc ;
open (FICHIER_INDEX, ">$fichier_index_jc");

    for ($cpt = 0 ; $cpt <= 23 ; $cpt++ )
    {
	if ( $tab_jc_heure[$cpt] == 0 )
	{
	    $buffer = $cpt.":"."-1".":"."-1"."\n" ;
	} else {
	    $buffer = $cpt.":".$debut_ligne.":".$tab_jc_heure[$cpt]."\n" ;
	    $debut_ligne = $debut_ligne + $tab_jc_heure[$cpt] ;
    }
	print(FICHIER_INDEX $buffer);
    }
 
close (FICHIER_INDEX);

