#!/usr/bin/perl
 
# Création d'un fichier index du access.log

#    Conception :
#    CETIAD - Revrchon kévin <kreverchon@ac-dijon.fr>

#    Copyright (C) 2000 


#    En attendant une traduction officielle de la GPL, la notice de 
#    copyright demeure en anglais.


#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#    Se reporter à la documentation envoyée avec le programme pour la notice.
#    Si elle manquait, envoyer un email à <kreverchon@ac-dijon.fr>


use strict;
use Getopt::Std ;

#Déclaration des variables
#Déclaration de la version



my $heure ;
my @tab ;
my @vect ;
my $fichier_index ;
my $debut_ligne ;
my $buffer ;
my $debut_ligne ;
my $version ;
my @jour ;






use vars qw($opt_i $opt_o $opt_v $opt_h);

#==============================================================================
#==============================================================================
#
#        
#                           Gestion des options
#
#==============================================================================

#<===========Copyright========>

my $copyright = "\n";
$copyright .= "    Perl-index-sem v. $version.\n\n";
$copyright .= "    Utilitaire d'index d'un fichier de log.\n";
$copyright .= "    Copyright (c) 2000 Kévin Reverchon <kreverchon\@ac-dijon.fr>.\n\n";
$copyright .= "    Perl-index-sem EST UN LOGICIEL LIBRE. SE RÉFÉRER AU CODE SOURCE\n";
$copyright .= "    POUR LA LICENCE D'UTILISATION ET DE COPIE.\n\n";

#<===========Message d'Aide==========>


my $help = "\n";
$help .= "Perl-index-sem v. $version.\n";
$help .= "Usage : 'perl-index-sem -i fichier_log  -o fichier_index'\n\n";
$help .= " perl-index-sem -h : affiche ce message d'aide.\n";
$help .= " perl-index-sem -v : affiche la version et la notice de copyright de CRéOLE.\n";

#<============lecture de la liste des options============>

unless( getopts('i:o:vh') )
{
    print STDERR $help;
    exit 0;
}

#affichage la version et le copyright si option -v

if( $opt_v )
{
    print STDERR $copyright;
    exit 0;
}

#affichage de l'aide si option -h

if($opt_h) 
{
    print STDERR $help;
    exit 0;
}
my $fichier_log ;
#gestion de l'option i
# Si l'option -i manque, affichage de l'aide

if( $opt_i ) 
{


    $fichier_log = $opt_i ;
    
} else {

    print STDERR $help;
    exit 0;
        
}
 
#gestion de l'option 
# Si l'option -o manque, affichage de l'aide
my $fichier_index ;
if( $opt_o ) 
{

    $fichier_index = $opt_o ;
    
} else {

    print STDERR $help;
    exit 0;

        
}


#=======================================================================================
#                                 fin gestion des options
#=======================================================================================





    for ($heure = 0 ; $heure <= 23 ; $heure++ )
    {
	$tab[$heure] = 0 ;
    }
 

`>$fichier_index` ;

open (FICHIER_LOG , $fichier_log) ;
while (<FICHIER_LOG>)
{

    @vect = split (/[ ]+/, $_, 1);



@jour = localtime($vect[0]) ;
$heure = $jour[2] ;
$tab[$heure]++ ;


}
close (FICHIER_LOG) ;

my $cpt ;
$debut_ligne = 1 ;
open (FICHIER_INDEX, ">$fichier_index");

    for ($cpt = 0 ; $cpt <= 23 ; $cpt++ )
    {
	if ( $tab[$cpt] == 0 )
	{
	    $buffer = $cpt.":"."-1".":"."-1"."\n" ;
	} else {
	    $buffer = $cpt.":".$debut_ligne.":".$tab[$cpt]."\n" ;
	    $debut_ligne = $debut_ligne + $tab[$cpt] ;
    }
	print(FICHIER_INDEX $buffer);
    }
 

close (FICHIER_INDEX);

