#!/bin/bash
#
#---------------------------------------------------
# Controle des services actifs
#
# Créer le fichier status utilisée par Eole-Admin
#
#---------------------------------------------------
. ParseDico

# test des interfaces et du routeur
echo -n "Reseau Local ";
if [ ! -z "$adresse_ip_eth3" ]
then
	/usr/bin/sudo /usr/sbin/fping $adresse_ip_eth0 $adresse_ip_eth1 $adresse_ip_eth2 $adresse_ip_eth3 &>/dev/null
elif [ ! -z "$adresse_ip_eth2" ]
then
	/usr/bin/sudo /usr/sbin/fping $adresse_ip_eth0 $adresse_ip_eth1 $adresse_ip_eth2 &>/dev/null
else 
	/usr/bin/sudo /usr/sbin/fping $adresse_ip_eth0 $adresse_ip_eth1 &>/dev/null
fi

if [ $? -eq 0 ]
	then
	echo "is alive"
else
	echo "failed"
fi
echo -n "Routeur Ext	";/usr/bin/sudo /usr/sbin/fping  $adresse_ip_gw  2>/dev/null
# test des services serveur local
echo -n "DNS	";tcpcheck  3 localhost:53    	#  DNS

echo -n "PROXY 	"
if [ ! -z "$adresse_ip_eth2" ];then
	tcpcheck 3 $adresse_ip_eth1:3128 $adresse_ip_eth2:3128 | grep -q failed
	RC=$?	
else
	tcpcheck 3 $adresse_ip_eth1:3128 | grep -q failed	
	RC=$?
fi
if [ $RC -ne 0 ];then
	echo "is alive"
else
	echo "failed"
fi

# test des services administrations serveur local
#echo -n "SSH	";tcpcheck  3 $adresse_ip_eth0:22    	#  SSH
# test des services distants
echo -n "Services Distants "
for dns in $adresse_ip_dns
do
DNS=$DNS' '$dns:53
done
tcpcheck  3 $DNS | grep -q alive       #  DNS
RC=$?
if [ "$nom_cache_pere" == "" ]
then
  tcpcheck 3 eole.ac-dijon.fr:80 www.renater.fr:80 www.$nom_domaine_academique:80 | grep -q alive
else
  tcpcheck 3 $nom_cache_pere:$port_cache_pere | grep -q alive
fi
RC=`expr $RC + $? `
if [ $RC -eq 0 ]
	then
	echo "is alive"
else
	echo "failed"
fi
# test TeLECH
if [ "$adresse_ip_serveur_acad_tlech" != "" ] 
then
	echo -n "TELECH		";tcpcheck 3 $adresse_ip_serveur_acad_tlech:6518 
fi
# Test RVP
if [ -x "/usr/share/eole/test-rvp" ] 
then
	echo -n "RVP      "
	sudo /usr/share/eole/test-rvp 2>&1 >/dev/null
	if [ "$?" -ne 0 ]
	then
		echo "Failed"
	else
		echo  "is alive"
		
	fi
fi

# test  Mise à jour
echo -n "Mise à jour"
if [ -f /var/www/ead/tmp/rapport-maj.html ] ;then
   tail -2 /var/www/ead/tmp/rapport-maj.html  | grep -q "OK" 2>&1 >/dev/null
   if [ $? -eq 0 ]
	then
	echo "is alive"
   else
	echo "failed"
   fi
else
 echo "is alive"
fi
