<?
/*
====================================================================================

          Module pour tout ce qui sert à l'authentification

====================================================================================

Ce module permet de valider ou de refuser une connexion, de logger les tentatives
de connexions, de crypter et d'ecrire le login et le password dans le fichier shadow


    Fonctions:

- string Authentificate($auth_login, $auth_password)
- array encrypt($login,$password)
- string writeShadow($newcrypt)

====================================================================================
*/



/*
====================================================================================
                       Fonction Authentification
====================================================================================

-
ce module gére l'authentification et l'accès à l'application  Eole admin
-

Fonctions

Authentificate
Encrypt
WriteShadow

-

Remarques:
Pas de remarques

-


====================================================================================
*/

/*

Authentificate
-
Résultat:
Retourne la valeur 1 ou 0 suivant si l'authentification a étét réussit oui ou non
-
Globales:
$password_path: le chemin du fichier ou il y a les infos pour l'authentification
$password_file: nom du fichier pour l'authentification
$path_log: chemin du fichier de log de connexion
$login_report: nom du fichier de log de connexion
File2String()
Add2File()
-
*/



 
function Authentificate($auth_login, $auth_password) 
{
   global $password_path, $password_file ;
   global $path_log, $login_report ;
   $logfile = $path_log.$login_report ;

   // cryptage des paramètres
   $tab= encrypt($auth_login,$auth_password);
   
   // récupération des info du 1er fichier de mot de passe
   $recup_info = File2String($password_path.$password_file);
   list($f_username,$f_password) = explode( ":", $recup_info);

   if (($tab['login']==$f_username) && ($tab['password']==$f_password)) {
      $msglog = PrintDate() ;
      $msglog .= "connexion (1)\n" ;
      Add2file($msglog, $logfile) ;
      return 1 ;
   
   } 
   elseif (file_exists($password_path.$password_file.'2')) {
      $recup_info = File2String($password_path.$password_file.'2');
      list($f_username,$f_password) = explode( ":", $recup_info);

      if (($tab['login']==$f_username) && ($tab['password']==$f_password)) {
         $msglog = PrintDate() ;
         $msglog .= "connexion (2)\n" ;
         Add2file($msglog, $logfile) ;
         return 2 ;
      } else {
         $msglog = PrintDate() ;
         $msglog .= "la connexion a échouée\n" ;
         Add2file($msglog, $logfile) ;
         return 0 ;
      }
   } else {
      $msglog = PrintDate() ;
      $msglog .= "la connexion a échouée\n" ;
      Add2file($msglog, $logfile) ;
      return 0 ;
   }
   
}


/*
=======================================================================================================

                                             Fonction encrypt

=======================================================================================================

- string encrypt($login,$password)

- crypte les variables $login et $password

- paramètres:
   $login, $password

- valeur retournée:
  array login, password

- références globales:
  aucunes
  Utilisée par confirmation-des-changements-de-login.php  
=======================================================================================================
*/
// crypatge de mots de user et de mots de passe
function encrypt($login,$password)  {

    $encrypted_username = crypt(substr($login, 0, 8),"Za");
    $encrypted_username .= substr(crypt(substr($login, 8, 8),"Za"),2,11);

    $encrypted_password = crypt(substr($password, 0, 8),substr($encrypted_username,2,2));
    $encrypted_password .= substr(crypt(substr($password, 8, 8),substr($encrypted_username,2,2)),2,11);

    return array ("login" => $encrypted_username
		  ,"password" => $encrypted_password
		  ) ;
}


/*
=======================================================================================================

                                           Fonction writeShadow

=======================================================================================================

- string writeShadow

- ecrit le nouveau mot de pass dans le fichier Shadow

- paramètre:
  $newcrypt

- valeur retournée:
  aucunes, mais ecriture dans le fichier Shadow

- références globales:
  aucunes
  Utilisée par confirmation-des-changements--de-login.php
=======================================================================================================
*/


function writeShadow($newcrypt) {

  global $password_path, $password_file ;  

  $file = $password_path.$password_file ;
  // shadow2
  if ($_SESSION["shadow"]=='2') $file.='2';
  $buffer = $newcrypt ; 
 
 //appel de la fonction string2file pour ecrire dans shadow  

  String2File($buffer,$file) ;
  
}

?>
