<?
/*
=======================================================================

   module de fonctions horaires 
   $Id: horaire-lib.inc,v 1.1.1.1 2004/01/05 10:17:33 eole Exp $

 Gestion des horaires personnalisés d'ouverture et de fermeture journaliers

 Fonctions : 

 Lit_horaire()  
 Ecrit_horaire()

 Affiche_form()
 Affiche_select()

=======================================================================
*/

/*
=======================================================================

 Affichage du formulaire des horaires 

=======================================================================
*/

/*
Affiche_form()
affiche le formulaire html des horaires
$horaire : le vecteur des horaires
renvoie le contenu du formulaire des horaires
*/

function Affiche_form( $horaire ) {

// Nous faisons la correspondance des jours de la sorte 
  $code_jour = array (
		     0 => 'dimanche'
		     , 1 => 'lundi'
		     , 2 => 'mardi'
		     , 3 => 'mercredi'
		     , 4 => 'jeudi'
		     , 5 => 'vendredi'
		     , 6 => 'samedi'
		     ) ;

  $formulaire = array() ;		    

  foreach ( $horaire as $ligne => $valeur ) {

   $select = Affiche_select( $valeur , $ligne ) ;

          $tmp = array( 
    		      'jour' => $code_jour[ $valeur[ 'jour' ] ]
    		      , 'ouvert' => $select[ 'ouvert' ]
    		      , 'ferme' => $select[ 'ferme' ] 
		      ) ;

          $formulaire[] = $tmp ;    

  }

  return $formulaire ;

}

/* 
Affiche_select ()
affiche une option de sélection pour le formulaire des horaires

$horaire = array( 
         'jour' => 0
         ,'ouvert' => 5
         ,'ferme' => 12 ) ;

$ligne : numéro de ligne servant d'index

renvoie le contenu d'une select box pour un horaire d'ouverture ou de fermeture
*/

function Affiche_select( $horaire , $ligne ) {

  // construction de la liste déroulante des horaires

  $code_heure = array () ;

  $code_heure[ '-' ] = '--------' ;

  for ($heure=0 ; $heure <= 23 ; $heure++) {
   $code_heure[ $heure ] = $heure . "h 00" ;	
  }
  
  // select pour l'horaire d'ouverture

  $select_ouvert = "ouvert[" . $ligne . "]" ;

  $ouvert = "<select name=\"$select_ouvert\">";

  foreach ( $code_heure as $code => $valeur ) {

    if ( strcmp(strval($horaire['ouvert']) , strval($code)) == 0) {
    // Si l'option est sélectionnée
      $ouvert .= "<option value=\"" . $code . "\" selected>" . $valeur . "</option>" ; 

    } else {
    // Si elle n'est pas sélectionnée
      $ouvert .= "<option value=\"" . $code . "\">" . $valeur . "</option>" ; 

    }

  }

  $ouvert .= "</select>\n" ;

  // construction du select pour l'horaire de fermeture

  $select_ferme = "ferme[" . $ligne . "]" ;

  $ferme = "<select name=\"$select_ferme\">";

  foreach ( $code_heure as $code => $valeur ) {

    if ( strcmp(strval($horaire['ferme']) , strval($code)) == 0) {
    // Si l'option est sélectionnée

      $ferme .= "<option value=\"" . $code . "\" selected>" . $valeur . "</option>" ; 

    } else {
    // Si elle n'est pas sélectionnée
      $ferme .= "<option value=\"" . $code . "\">" . $valeur . "</option>" ; 

    }

  }

  $ferme .= "</select>\n" ;

  // Nous déclarons le vecteur de retour de la fonction 
  $select = array (
                   'ouvert' => $ouvert
                   , 'ferme' => $ferme  
                  ) ;
  return $select ;		  

}

/*
=======================================================================

 sérialisations dans le fichier horaire

=======================================================================
*/

/*
Lit_horaire()
-
Split le contenu du fichier horaire
-
Paramatres:
fichier à parser (horaire.txt)
-
Resultat:
retourne un vecteur contenant les données horaires
-
*/

function Lit_horaire( $txt ) 
 
{


    if ( file_exists( $txt ) ) {

  $fichier = file ( $txt ) ;

  $horaire = array () ;

} else {

// on reconstruit un fichier horaires par défaut
$fichier = array() ;
$fichier[]= "1 7 19 " ;
$fichier[]= "2 7 19 " ;
$fichier[]= "3 7 19 " ;
$fichier[]= "4 7 19 " ;
$fichier[]= "5 7 19 " ;
$fichier[]= "6 7 14 " ;
$fichier[]= "0 - - " ;

}
  
  if ( is_array ( $fichier ) ) { 

      foreach ( $fichier as $ligne )
     
        {
          
          $tmp = split (" " ,$ligne) ;
    
          $tmp2 = array( 
    		      'jour' => "$tmp[0]"
    		      ,'ouvert' => "$tmp[1]"
    		      ,'ferme' => "$tmp[2]"		      
    				      ) ;
          $horaire[] = $tmp2 ;
    
        }

  return $horaire ;

  }
}

/*
Ecrit_horaire()
-
Ecrit dans le fichier horaire
-
Paramatres :
vecteur à sérialiser , nom du fichier
-
Resultat :
aucun
-
*/

function Ecrit_horaire( $horaire , $fichier ) {

  $tmp = "" ;

  foreach ( $horaire as $clef => $val ) {

      $tmp .= $val['jour']." ".$val['ouvert']." ".$val['ferme']." \n" ;

    }

      // ouverture du fichier en écriture seule, pointeur en tete du fichier

            $file_handler = fopen($fichier,'w') ;

            // le fichier existe,ouverture
	    fwrite( $file_handler , $tmp ) ;

	    fclose( $file_handler ) ;


}

/*
=======================================================================

 tests unitaires

=======================================================================
*/

function horaire_lib () {


// Nous déclarons un vecteur horaire fictif

    $tmp  = array (
         array( 
         'jour' => 0
         ,'ouvert' => 5
         ,'ferme' => 12
         )
        , array( 
         'jour' => 1
         ,'ouvert' => 6
         ,'ferme' => 22
         )
        , array( 
        'jour' => 2
        ,'ouvert' => 4
        ,'ferme' => 23
        )
                   ) ;

// test de sérialisation 

    Ecrit_horaire ( $tmp, "/var/www/ead/tmp/horaires.txt" ) ;
    
    $horaire = Lit_horaire( "/var/www/ead/tmp/horaires.txt" ) ;
    
// sortie du test 

    if ( $horaire == $tmp ) {

       print "horaire-lib : serialisations____OK\n" ;

    } else {

       print "horaire-lib : serialisations____ERREUR\n" ;

    }

// test d'affichage 

print_r (Affiche_form( $tmp ) ) ;

}

?>
