# -*- coding: utf-8 -*- 
"""fichier de configuration du parseur de logs"""
import os.path as osp

# repertoire du fichier de conf 
HERE = osp.dirname(osp.abspath(__file__))

# répertoire du log du jour 
LOGFILE_PATH = "/var/log/squid/"

# répertoire des fichiers compressés par le logrotate 
ZIPPED_LOGFILE_PATH = "/var/log/squid/"

# nom du fichier de logs
LOGFILE_NAME = "access.log"

# format des logs de squid (la date est en isoformat)
KEYWORDS = ['date','login','ip', 'url', 'method', 'chiffre1', 'chiffre2']

# html template directory (affichage des résultats)
TEMPLATE_DIR = osp.join(HERE, "html")

# nom de la page d'affichage des résultats
RESULT_PAGE = 'int-affiche-squid-horaire.php'

# intervalle de query horaire pour l'affichage
SCHEDULE = ["00-24", "00-02", "02-04", "04-06", "06-08", "08-10", "10-12", "12-14", "14-16", "16-18", "18-20", "20-22", "22-24"]

# nom du programme à executer depuis la page
# cet executable devra être lancé avec les bonnes options
EXECUTABLE = osp.join(HERE, "logparser")



