# -*- coding: utf-8 -*-
###########################################################################
# 
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
# eole@ac-dijon.fr 
#  
###########################################################################
"""
utilitaire de compression et de décompression de fichier
"""

import gzip
import os.path as osp
from errors import DataError

class Zip:
    """utilitaire de compression et de décompression de fichier
    au format gzip (equivalent de gunzip)
    """
    def __init__(self, fname):
        if osp.isfile(fname):
            self.fname = fname
        else:
            raise DataError
        self.content = None
        # self._unzip()
        
    def _unzip(self):
        fhandle = gzip.GzipFile(self.fname, 'r');
        self.content = fhandle.read()
        fhandle.close()

    def get_content(self):
        self._unzip()
        return self.content

    def get_handle(self):
        return gzip.GzipFile(self.fname, 'r');

def get_content(fname):
    """recuperation du contenu du fichier zippé"""
    z = Zip(fname)
    return z.get_content()

def get_handle(fname):
    """recuperation du hangle de fichier (comme s'il s'agissait d'un 
    fichier normal, non zippé"""
    z = Zip(fname)
    return z.get_handle()
    
#  # compressing a file
# import gzip
# fileObj = gzip.GzipFile("/Users/mary/hamlet.txt.gz", 'wb');
# fileObj.write(fileContent)
# fileObj.close()


