<?
/*
=======================================================================

   Gestionnaire de Période
   $Id: periode-lib.inc,v 1.1.1.1 2004/01/05 10:17:33 eole Exp $
=======================================================================

-

Détermination des index, fichiers, et variables nécessaires
au repérage des données dans les logs.
- 

 Fonctions : 

// sélection des types d'affichage 

per_<nom-de-fichier>
    per_determine_Periode

-

 Remarques :

-
=======================================================================
*/


/*
=======================================================================

   Sélection du fichier à manipuler

=======================================================================
*/

  /*
    per_determine_Periode
    -
    gestionnaire de semaine : détermine quel fichier de log et d'index a prendre, 
    celui de la semaine ou de la semaine dernière, exception pour le jour courant pas d'index    -
    Paramètres : 
    str_select_week , str_select_lastweek
    -
    Résultat :
    retourne un vecteur avec le nom du fichier de log et d'index a prendre,
    sauf pour le jour cournat ou il n'y a que le fichier de log
    -
    Globales :
    $data_access_squid ,  $data_access_squid_sem_dern
    $file_indexation_week , $file_indexation_lastweek 
    - 
  */

function per_determine_Periode() 
{

  global $ses_select_week ,  $ses_select_lastweek ;


  //global $data_access_squid ,  $data_access_squid_sem_dern

  global $data_access_squid_jour_courant ;

  //  global $fic_index_sem , $fic_index_sem_dern 
  
  global $jour_courant_log , $fic_index_jc ;

  global $path_log ;

  if ( $ses_select_week != "" )
   {

     $str_jour = $ses_select_week ;

     $file_fichierPeriode =  $path_log.$str_jour."-sem.log" ;
     $file_index_retour = $path_log.$str_jour."-index.ead" ;
     
     $vect_returnNameFile  = array (
		   'file_log' => $file_fichierPeriode
		   ,'file_index' => $file_index_retour
		   ) ;
     
     return $vect_returnNameFile ;

    } else {

      if ($ses_select_lastweek != "")
      {

	$str_jour = $ses_select_lastweek ;

	/*
	$file_fichierPeriode =  $squid_path.$data_access_squid_sem_dern ;
	$file_index_retour = $path_log.$fic_index_sem_dern ;
	*/

	$file_fichierPeriode =  $path_log.$str_jour."-semdern.log" ;
	$file_index_retour = $path_log.$str_jour."-index-semdern.ead" ;

	$vect_returnNameFile  = array (
				       'file_log' => $file_fichierPeriode
				       ,'file_index' => $file_index_retour
				       ) ;

	
	return $vect_returnNameFile ;

	} else {

	  // FIXME : faire les bons règlages pour le jour courant
	  global $engine_path ,  $perl_dispatch_jc , $squid_path ,  $data_access_squid  ,  $path_log , $debut_ligne_jc , $perl_index_jc   ;
    // essai de debug GWEN
    $script = $engine_path.$perl_dispatch_jc ;
    $i = $squid_path.$data_access_squid ;
    $o = $path_log.$jour_courant_log ;
    $l = $path_log.$debut_ligne_jc ;

	  `$script -i $i -o $o -l $l` ;
$script = $engine_path.$perl_index_jc ;
$i = $path_log.$jour_courant_log ;
$o = $path_log.$fic_index_jc ;
	  `$script -i $i -o $o` ;

	  $file_fichierPeriode =  $path_log.$jour_courant_log ;
	  $file_index_retour = $path_log.$fic_index_jc ;

	  $vect_returnNameFile  = array (
					 'file_log' => $file_fichierPeriode
					 ,'file_index' => $file_index_retour
					 ) ;
	
	  return $vect_returnNameFile ;
	
	  
	}
    }

}

/*
=======================================================================

    Désérialisations

=======================================================================
*/



  /*
    per_deserial_Indexation
    -
    Interroge l'index sérialisé par le script perl du cron
    suivant les deux paramètres de l'intervalle
    -
    Paramètres : 
    $file_indexation // nom du fichier d'index
    $int_heureDeb // début de l'intervalle 
    $int_heureFin // fin de l'intervalle
    -
    Résultat :
    Renvoie un vecteur composé d'un numéro de ligne et d'un nombre de lignes
    -
    Globales :

    - 
    Remarques : 

    
  */

function per_deserial_Indexation( 
				$file_indexation 
			      , $int_heureDeb
			      , $int_heureFin
				, $int_num_jour 
				) 
{

  global $ses_select_week , $ses_select_lastweek ;

 $str_ligneFichierIndexation = Explose_Fichier( $file_indexation ) ;

 $int_nbLigne = 0 ;
 $int_compteur = 0 ;

  if ( is_array( $str_ligneFichierIndexation ) )  
    {


      foreach ( $str_ligneFichierIndexation as $str_val )
	{
      
	  $vect_bufferSplit = split (":" ,$str_val) ;
	  $vect_bufferSplit[2] = str_replace("\n","",$vect_bufferSplit[2]) ;

	  /*
	    $v[0]= heure,
	    $v[1]= ligne de commencement des log pour ce jour là et cette heure là,
	    $v[2] = nombre de lignes
	  */



	  
	  if  ( ( $vect_bufferSplit[0] >= $int_heureDeb ) && ( $vect_bufferSplit[0] <= $int_heureFin ) )
	    {
              if (($vect_bufferSplit[1] != -1) && ($int_compteur == 0))
		{
		  $int_compteur =  1;
	        } else {
		  $int_compteur = 0 ;
		}
	      
	      if ($vect_bufferSplit[2] != -1)
		{
	      $int_nbLigne = $int_nbLigne + $vect_bufferSplit[2] ;
		}
	      if ( $int_compteur == 1 )
		{

		  $debut_ligne = $vect_bufferSplit[1] ;

		}
	      	       
	    }

	}

    }

  if ( ( $int_heureDeb == 0 ) && ( $int_heureFin == 23 ) )
    {
      $debut_ligne = 1 ;
    }

  $vect_returnBuffer  = array (
			       'int_debutLigne' => $debut_ligne
			       ,'int_nbLigne' => $int_nbLigne
		   ) ;

  return $vect_returnBuffer ;

}



?>
