<?
/*
=======================================================================

   Récupération des logs
   $Id: recup-log-lib.inc,v 1.1.1.1 2004/01/05 10:17:33 eole Exp $
=======================================================================

-
 Procédures de récupération d'une portion de log, 
 et retour des données dans un vecteur
- 

 Fonctions : 

// sélection des types d'affichage 

rec_<nom-de-fichier>
    rec_get_Requete
    rec_parse_Requete
-

 Remarques :

-
=======================================================================
*/


/*
=======================================================================

   Parsing et mise des données dans un fichier temporaire

=======================================================================
*/

  /*
    rec_get_Requete
    -
   
    -
    Paramètres : 

    $debut_ligne, $nb_ligne, // intervalle de filtrage
    $file_buffer // le fichier de log à interroger
    -
    Résultat :
    la portion de log demandée
    -
    Globales :

    - 
    Remarques : 

       
  */

function rec_get_Requete( $debut_ligne , $file_fichierPeriode ) 
{

  global $ses_file_tmp , $ses_nbligne ;

  $file_bufferTemp = create_FileID () ;

  // renseigner la variable de session du nom de fichier
  $ses_file_tmp = $file_bufferTemp ;
  
  `tail +$debut_ligne $file_fichierPeriode | head -$ses_nbligne > $file_bufferTemp` ;

  return $file_bufferTemp ;

}

  /*
    rec_parse_Requete
    -
    Parse un buffer tampon dans lequel figure une requete, 
    De manière à générer une sortie vectorielle
    -
    Paramètres : 
    
    $str_requete // buffer de logs

    -
    Résultat :

    vecteur (structure de données à afficher)
    -
    Globales :

    - 
    Remarques : 

    il est bien entendu qu'il ne faut pas balancer n'importe quoi 
    comme buffer dans cette fonction puisqu'à partir de là 
    c'est un vecteur php qui est retourné !
    
  */

function rec_parse_Requete( $str_requete ) 
{

  $vect_requete = explode ( "\n" , $str_requete ) ;

  $vide = array_pop ($vect_requete) ;
  
  foreach ( $vect_requete as $val )  {
	
    // il faut spliter la ligne sur plusieurs espaces (pas de explode ici)

    $vect = split ( '[ ]+' , $val ) ;

      
    // transcription "lisible" du timestamp

    $heure = humanDate( $vect[0] ) ;

    $result[] = array(
		      'time' => $heure
		      ,'ip' => $vect[2] 
		      ,'url' => $vect[6]
		      ,'referant' => $vect[7]
		      ) ;

  }

  return $result ;

}




/*
=======================================================================

   Parsing et mise des données dans un buffer

=======================================================================
*/

  /*
    rec_get_RequeteFileTemp
    -
    Interroge un fichier de log directement et en retire 
    un échantillon suivant la requete considérée
    -
    Paramètres : 

    $debut_ligne, $nb_ligne, // intervalle de filtrage
    $file_buffer // le fichier de log à interroger
    -
    Résultat :
    la portion de log demandée
    -
    Globales :

    - 
    Remarques : 

    il est bien entendu qu'il ne faut pas balancer n'importe quoi 
    comme file_buffer dans cette fonction 
    puisque le but sera de mettre les données dans un vecteur.
    
  */

function rec_get_RequeteFileTemp() 
{

  global $ses_file_tmp , $ses_num_ligne_debutpage ;

  $int_nb_ligne = NB_LIGNE_MAX ;

  $str_bufferFileTemp  = `tail +$ses_num_ligne_debutpage $ses_file_tmp | head -$int_nb_ligne` ;

  return $str_bufferFileTemp ;

}




/*
=======================================================================

  sous-modules suivant les types de pages d'affichage squid   

=======================================================================
*/


  /*
    rec_get_RequeteGrepIp
    -
   
    -
    Paramètres : 

    $debut_ligne, $nb_ligne, // intervalle de filtrage
    $file_buffer // le fichier de log à interroger
    -
    Résultat :
    la portion de log demandée
    -
    Globales :

    - 
    Remarques : 

       
  */

function rec_get_RequeteGrepIp( $file_fichierPeriode ) 
{

  global $ses_file_tmp , $ses_select_ip , $ses_nbligne ;

  $file_bufferTemp = create_FileIDGrep () ;

  // renseigner la variable de session du nom de fichier
  $ses_file_tmp = $file_bufferTemp ;
  
  `grep $ses_select_ip $file_fichierPeriode > $ses_file_tmp` ;

  $ses_nbligne = `wc -l $ses_file_tmp` ;

  return $file_bufferTemp ;

}


  /*
    rec_get_RequeteGrepReferant
    -
   
    -
    Paramètres : 

    $debut_ligne, $nb_ligne, // intervalle de filtrage
    $file_buffer // le fichier de log à interroger
    -
    Résultat :
    la portion de log demandée
    -
    Globales :

    - 
    Remarques : 

       
  */

function rec_get_RequeteGrepReferant( $file_fichierPeriode ) 
{

  global $ses_file_tmp , $ses_select_referant , $ses_nbligne ;

  $file_bufferTemp = create_FileIDGrep () ;

  // renseigner la variable de session du nom de fichier
  $ses_file_tmp = $file_bufferTemp ;
  
  `grep $ses_select_referant $file_fichierPeriode > $ses_file_tmp` ;

  $ses_nbligne = `wc -l $ses_file_tmp` ;

  return $file_bufferTemp ;

}


  /*
    rec_get_RequeteGrepHost
    -
   
    -
    Paramètres : 

    $debut_ligne, $nb_ligne, // intervalle de filtrage
    $file_buffer // le fichier de log à interroger
    -
    Résultat :
    la portion de log demandée
    -
    Globales :

    - 
    Remarques : 

       
  */

function rec_get_RequeteGrepHost( $file_fichierPeriode ) 
{

  global $ses_file_tmp , $ses_select_host , $ses_nbligne ;

  $file_bufferTemp = create_FileIDGrep () ;

  // renseigner la variable de session du nom de fichier
  $ses_file_tmp = $file_bufferTemp ;
  
  `grep $ses_select_host $file_fichierPeriode > $ses_file_tmp` ;

  $ses_nbligne = `wc -l $ses_file_tmp` ;

  return $file_bufferTemp ;

}


?>
