<?
/*
=======================================================================

   Gestionnaire d'affichage 
   $Id: select-affichage-lib.inc,v 1.4 2004/02/24 10:07:50 joel Exp $
=======================================================================

-

Sélection de l'affichage en fonction du volume de données à présenter.

- 

 Fonctions : 

// sélection des types d'affichage 
aff_determine_Affichage
aff_determine_AffichageTelQuel
aff_determine_NavHoraire
aff_determine_NavPage

aff_affiche_PageSuivante
aff_affiche_TelQuel

-

 Remarques :

les variables de fonctions sont utilisées dans aff_affiche_TelQuel

-
=======================================================================
*/


/*
=======================================================================

   gestion des différents types d'affichage (modèle) 

=======================================================================
*/

  /*
    aff_determine_AffichageTelQuel
    -

    portion d'affichage suivant le modèle de navigation tel quel

    -
    Paramètres : 

    -
    Résultat :

    -
    Globales :

    - 
  */

function aff_determine_AffichageTelQuel() 
{

  global $ses_num_ligne_debutpage ;

  // construction du gestionnaire d'affichage de la sortie "Tel Quel"

  $str_select_aff_TelQuel = aff_affiche_TelQuel() ;

  $fct_aff_TelQuel = "FormatageResultat".$str_select_aff_TelQuel ;

  // récupération des données

  $int_nb_ligne = NB_LIGNE_MAX ;

  $str_requete = rec_get_RequeteFileTemp() ;

  $vect_resultatLog = rec_parse_Requete( $str_requete ) ;

  if ( is_array( $vect_resultatLog ) )
  {


  // sortie html 
  $str_bufferHtml = $fct_aff_TelQuel( $vect_resultatLog ) ;
    

  } else  
  {

    $str_bufferHtml = "la sélection choisie est vide" ;

  }

  return $str_bufferHtml ;

}

  /*
    aff_determine_Affichage 
    -
    gestionnaire de sortie html : détermine quelle présentation adopter
    suivant la quantités de logs à traiter
    -
    Paramètres : 

    -
    Résultat :
    Renvoie une string qui est le préfixe de la fonction d'affichage
    -
    Globales :

    - 
    Remarques : 
    Cette fonction récupère en fait la variable de session 
    ses_nb_ligne et fait un test dessus.
    
  */

function aff_determine_Affichage() 
{

  global $ses_nbligne ;

  if ( $ses_nbligne >= NB_LIGNE_MAX ) 
    {


      aff_affiche_PageSuivante() ;

      return $str_nomFonction ;
      
    } else  
      {


	aff_determine_AffichageTelQuel() ;
  
	return $str_nomFonction ;
	
      }

}

/*
=======================================================================

   navigateur par page : détermination du type de page

=======================================================================
*/


  /*
    aff_determine_NavPage

    -

    Construit la structure du navigateur par page

    -
    Paramètres : 

    $int_num_ligne_debutPage //numéro de ligne de la page courante 
    // correspondant à ses_num_ligne_debutPage
    $int_nb_ligne // nombre de ligne total de la trache filtrée par le tail
    
    -
    Résultat :

    renvoie le navigateur par page dans bon positionnement des boutons
    
    -
    Globales :

    NB_LIGNE_MAX // constante d'affichage d'une page
    htm_affiche_NavPage // fonction d'affichage html

    - 
  */

function aff_determine_NavPage( $url_lien )   
{
  global $ses_select_referant, $ses_select_ip, $ses_select_host;
  global $ses_num_ligne_debutpage, $ses_nbligne ;

  $int_reste_ligne = $ses_nbligne - $ses_num_ligne_debutpage ;

  // fixation (en dur...) des liens auto-appelant

  $url_lienPrecedent = $url_lien."?url_page=precedent&url_referant=".$ses_select_referant."&url_ip=".$ses_select_ip."&url_host=".$ses_select_host ;
  $url_lienSuivant = $url_lien."?url_page=suivant&url_referant=".$ses_select_referant."&url_ip=".$ses_select_ip."&url_host=".$ses_select_host ;

  if ( $ses_num_ligne_debutpage == 1 )
    {

      $str_buffer = htm_affiche_NavPage( FALSE , "" , TRUE , $url_lienSuivant) ;
      
      return $str_buffer ;

    } else  
      {

	if ( $int_reste_ligne <= NB_LIGNE_MAX ) 
	  {

	    $str_buffer = htm_affiche_NavPage( TRUE , $url_lienPrecedent , FALSE , "" ) ;	    
	    return $str_buffer ;

	  } else  
	    {

	      $str_buffer = htm_affiche_NavPage( TRUE , $url_lienPrecedent  , TRUE , $url_lienSuivant ) ;

	      return $str_buffer ;

	    }

      }

}

  /*
	aff_incremente_NavPage
    -
    positionne la valeur du numéro de ligne par page suivant la demande du navigateur
    par page
    -
    Paramètres : 

    -
    Résultat :

    -
    Globales :

    - 
  */

function aff_incremente_NavPage()   
{

  global $ses_num_ligne_debutpage , $url_page ;

  if ( $url_page == "precedent" ) 
    {

      $ses_num_ligne_debutpage = $ses_num_ligne_debutpage - NB_LIGNE_MAX ;
      
    } else  
      {

	if ( $url_page == "suivant" ) 
	  {

	    $ses_num_ligne_debutpage = $ses_num_ligne_debutpage + NB_LIGNE_MAX ;

	  } else  
	    {

	      // si le contenu de la variable est vide, ne fait rien

	    }

      }

}

/*
=======================================================================

    construction du navigateur horaire

=======================================================================
*/

  /*
    aff_determine_NavHoraire
    -
    Renvoie le navigateur si on n'est pas dans le cas journée

    Cette fonction ne sert plus à rien car il faut le mettre finalement...

    -
    Paramètres : 

    $str_select_horaire // attend la variable de session url_horaire

    -
    Résultat :

    html (le navigateur)

    -
    Globales :

    aucune

    - 
  */

function aff_determine_NavHoraire()   
{

  global $ses_select_horaire ;

  if( $ses_select_horaire == "00-23" )  
    {

      // n'affiche pas le navigateur horaire

      // $str_buffer = "" ;

      $str_buffer = htm_affiche_NavHoraire() ;
      
      return $str_buffer ;

    } else  
      {

	// affiche le navigateur horaire

	$str_buffer = htm_affiche_NavHoraire() ;

	return $str_buffer ;

      }

}

/*
=======================================================================

   Sous-module de gestion sur l'horaire   

=======================================================================
*/

  /*
    aff_affiche_PageSuivanteHoraire
    -
    
    portion d'affichage suivant le modèle de navigation page par page

    -
    Paramètres : 

    $int_num_ligne_debutPage // en fait ses__num_ligne_debutPage
    $int_nb_ligne // en fait ses_nb_ligne

    -
    Résultat :

    -
    Globales :

    - 
  */

function aff_affiche_PageSuivanteHoraire()
{

  //  $str_bufferHtml .= aff_determine_NavHoraire() ;

  // affichage par page 
  //  $str_bufferHtml .= aff_determine_NavPage("int-affiche-squid-horaire.php") ;

  $str_bufferHtml = aff_determine_AffichageTelQuelHoraire() ;

  // affichage par page 
  $str_bufferHtml .= aff_determine_NavPage("int-affiche-squid-horaire.php") ;



  echo $str_bufferHtml ;

}

  /*
    aff_determine_AffichageHoraire 
    -
    gestionnaire de sortie html : détermine quelle présentation adopter
    suivant la quantités de logs à traiter
    -
    Paramètres : 

    -
    Résultat :
    Renvoie une string qui est le préfixe de la fonction d'affichage
    -
    Globales :

    - 
    Remarques : 
    Cette fonction récupère en fait la variable de session 
    ses_nb_ligne et fait un test dessus.
    
  */

function aff_determine_AffichageHoraire() 
{

  global $ses_nbligne ;

  if ( $ses_nbligne >= NB_LIGNE_MAX ) 
    {


      aff_affiche_PageSuivanteHoraire() ;

      return $str_nomFonction ;
      
    } else  
      {


	$str_bufferHtml = aff_determine_AffichageTelQuelHoraire() ;
  
	return $str_bufferHtml ;
	
      }

}

  /*
    aff_determine_AffichageTelQuelHoraire
    -

    portion d'affichage suivant le modèle de navigation tel quel

    -
    Paramètres : 

    -
    Résultat :

    -
    Globales :

    - 
  */

function aff_determine_AffichageTelQuelHoraire() 
{

  global $ses_num_ligne_debutpage ;

  // récupération des données

  //  $int_nb_ligne = NB_LIGNE_MAX ;

  $str_requete = rec_get_RequeteFileTemp() ;

  $vect_resultatLog = rec_parse_Requete( $str_requete ) ;

  if ( is_array( $vect_resultatLog ) )
  {

  // sortie html 
  $str_bufferHtml = FormatageResultat( $vect_resultatLog ) ;
  $str_bufferHtml .= aff_determine_NavHoraire() ;

  } else  
  {

    $str_bufferHtml = "la sélection choisie est vide" ;

  }

  return $str_bufferHtml ;

}

/*
=======================================================================

   Sous-module de gestion sur l'ip

=======================================================================
*/

  /*
    aff_affiche_PageSuivanteIp
    -
    
    portion d'affichage suivant le modèle de navigation page par page

    -
    Paramètres : 

    $int_num_ligne_debutPage // en fait ses__num_ligne_debutPage
    $int_nb_ligne // en fait ses_nb_ligne

    -
    Résultat :

    -
    Globales :

    - 
  */

function aff_affiche_PageSuivanteIp()
{

  // affichage par page 
   $str_bufferHtml .= aff_determine_NavPage("int-affiche-squid-ip.php") ;

  $str_bufferHtml = aff_determine_AffichageTelQuelIp() ;

  // affichage par page 
   $str_bufferHtml .= aff_determine_NavPage("int-affiche-squid-ip.php") ;

  //  $str_bufferHtml .= aff_determine_NavHoraire() ;

  echo $str_bufferHtml ;

}

  /*
    aff_determine_AffichageIp
    -
    gestionnaire de sortie html : détermine quelle présentation adopter
    suivant la quantités de logs à traiter
    -
    Paramètres : 

    -
    Résultat :
    Renvoie une string qui est le préfixe de la fonction d'affichage
    -
    Globales :

    - 
    Remarques : 
    Cette fonction récupère en fait la variable de session 
    ses_nb_ligne et fait un test dessus.
    
  */

function aff_determine_AffichageIp() 
{

  global $ses_nbligne ;

  if ( $ses_nbligne >= NB_LIGNE_MAX ) 
    {


      aff_affiche_PageSuivanteIp() ;

      return $str_nomFonction ;
      
    } else  
      {


	$str_bufferHtml = aff_determine_AffichageTelQuelIp() ;
  
	return $str_bufferHtml ;
	
      }

}


  /*
    aff_determine_AffichageTelQuelIp
    -

    portion d'affichage suivant le modèle de navigation tel quel

    -
    Paramètres : 

    -
    Résultat :

    -
    Globales :

    - 
  */

function aff_determine_AffichageTelQuelIp() 
{

  global $ses_num_ligne_debutpage ;

  // Récupération des données

  //  $int_nb_ligne = NB_LIGNE_MAX ;

  $str_requete = rec_get_RequeteFileTemp() ;

  $vect_resultatLog = rec_parse_Requete( $str_requete ) ;

  if (is_array($vect_resultatLog) )
  {

  // sortie html 
  $str_bufferHtml = FormatageResultatIP( $vect_resultatLog ) ;

  } else  
  {

    $str_bufferHtml = "la sélection choisie est vide" ;

  }

  return $str_bufferHtml ;

}

/*
=======================================================================

   Sous-module de gestion sur le référant

=======================================================================
*/

  /*
    aff_affiche_PageSuivanteReferant
    -
    
    portion d'affichage suivant le modèle de navigation page par page

    -
    Paramètres : 

    $int_num_ligne_debutPage // en fait ses__num_ligne_debutPage
    $int_nb_ligne // en fait ses_nb_ligne

    -
    Résultat :

    -
    Globales :

    - 
  */

function aff_affiche_PageSuivanteReferant()
{

  // affichage par page 
  $str_bufferHtml .= aff_determine_NavPage("int-affiche-squid-referant.php") ;

  $str_bufferHtml = aff_determine_AffichageTelQuelReferant() ;

  // affichage par page 
  $str_bufferHtml .= aff_determine_NavPage("int-affiche-squid-referant.php") ;

  //  $str_bufferHtml .= aff_determine_NavHoraire() ;

  echo $str_bufferHtml ;

}

  /*
    aff_determine_AffichageReferant
    -
    gestionnaire de sortie html : détermine quelle présentation adopter
    suivant la quantités de logs à traiter
    -
    Paramètres : 

    -
    Résultat :
    Renvoie une string qui est le préfixe de la fonction d'affichage
    -
    Globales :

    - 
    Remarques : 
    Cette fonction récupère en fait la variable de session 
    ses_nb_ligne et fait un test dessus.
    
  */

function aff_determine_AffichageReferant() 
{

  global $ses_nbligne ;

  if ( $ses_nbligne >= NB_LIGNE_MAX ) 
    {


      aff_affiche_PageSuivanteReferant() ;

      return $str_nomFonction ;
      
    } else  
      {


	$str_bufferHtml = aff_determine_AffichageTelQuelReferant() ;
  
	return $str_bufferHtml ;
	
      }

}


  /*
    aff_determine_AffichageTelQuelReferant
    -

    portion d'affichage suivant le modèle de navigation tel quel

    -
    Paramètres : 

    -
    Résultat :

    -
    Globales :

    - 
  */

function aff_determine_AffichageTelQuelReferant() 
{

  global $ses_num_ligne_debutpage ;

  // récupération des données

  //  $int_nb_ligne = NB_LIGNE_MAX ;

  $str_requete = rec_get_RequeteFileTemp() ;

  $vect_resultatLog = rec_parse_Requete( $str_requete ) ;

  if (is_array($vect_resultatLog) )
  {

  // sortie html 
  $str_bufferHtml = FormatageResultatReferant( $vect_resultatLog ) ;

  } else  
  {

    $str_bufferHtml = "la sélection choisie est vide" ;

  }

  return $str_bufferHtml ;

}

/*
=======================================================================

   Sous-module de gestion sur l'hôte

=======================================================================
*/

  /*
    aff_affiche_PageSuivanteHost
    -
    
    portion d'affichage suivant le modèle de navigation page par page

    -
    Paramètres : 

    $int_num_ligne_debutPage // en fait ses__num_ligne_debutPage
    $int_nb_ligne // en fait ses_nb_ligne

    -
    Résultat :

    -
    Globales :

    - 
  */

function aff_affiche_PageSuivanteHost()
{

  // affichage par page 
  $str_bufferHtml .= aff_determine_NavPage( "int-affiche-squid-host.php" ) ;

  $str_bufferHtml = aff_determine_AffichageTelQuelHost() ;

  // affichage par page 
  $str_bufferHtml .= aff_determine_NavPage( "int-affiche-squid-host.php" ) ;

  // $str_bufferHtml .= aff_determine_NavHoraire() ;

  echo $str_bufferHtml ;

}

  /*
    aff_determine_AffichageHost
    -
    gestionnaire de sortie html : détermine quelle présentation adopter
    suivant la quantités de logs à traiter
    -
    Paramètres : 

    -
    Résultat :
    Renvoie une string qui est le préfixe de la fonction d'affichage
    -
    Globales :

    - 
    Remarques : 
    Cette fonction récupère en fait la variable de session 
    ses_nb_ligne et fait un test dessus.
    
  */

function aff_determine_AffichageHost() 
{

  global $ses_nbligne ;

  if ( $ses_nbligne >= NB_LIGNE_MAX ) 
    {


      aff_affiche_PageSuivanteHost() ;

      return $str_nomFonction ;
      
    } else  
      {


	$str_bufferHtml = aff_determine_AffichageTelQuelHost() ;
  
	return $str_bufferHtml ;
	
      }

}


  /*
    aff_determine_AffichageTelQuelHost
    -

    portion d'affichage suivant le modèle de navigation tel quel

    -
    Paramètres : 

    -
    Résultat :

    -
    Globales :

    - 
  */

function aff_determine_AffichageTelQuelHost() 
{

  global $ses_num_ligne_debutpage ;

  // récupération des données

  //  $int_nb_ligne = NB_LIGNE_MAX ;

  $str_requete = rec_get_RequeteFileTemp() ;

  $vect_resultatLog = rec_parse_Requete( $str_requete ) ;

  if (is_array($vect_resultatLog) )
  {

  // sortie html 
  $str_bufferHtml = FormatageResultatHost( $vect_resultatLog ) ;

  } else  
  {

    $str_bufferHtml = "la sélection choisie est vide" ;

  }

  return $str_bufferHtml ;

}

?>
